# 日本郵便の郵便番号データ（http://www.post.japanpost.jp/zipcode/dl/kogaki/lzh/ken_all.lzh）を
# Mac OS X v10.5 "Leopard"の辞書アプリケーション（Dictionary.app）用に変換
# v0.01 by Tats_y (http://www.binword.com/blog/)
# 2007/11/20

$KCODE = "UTF-8"
require 'iconv'
require 'cgi'
require 'nkf'
require 'tempfile'
require 'csv'

temp = Tempfile.new("my-temp")

iconv = Iconv.new('UTF-8', 'CP932')  # UTF-8のテンポラリファイルを作成
File.open("KEN_ALL.CSV"){|file|
  while line = file.gets
  next if line.strip.empty?
  line1 = iconv.iconv(line)
  temp.puts line1
end
}
temp.close

x= 0
kanji_choiki = ""
yomi_choiki = ""

print '<?xml version="1.0" encoding="UTF-8"?>' + "\n"
print '<d:dictionary xmlns="http://www.w3.org/1999/xhtml" xmlns:d="http://www.apple.com/DTDs/DictionaryService-1.0.rng">' + "\n"

CSV.open(temp.path, 'r'){|row|
  x = x + 1

if row.to_a[8] =~ /^[^０-９].*（.+[^）]$/ or row.to_a[8] =~ /^[０-９－、・〜].*[^）]$/ then  # 町域が2行以上にまたがるケースの1行目以降（最終行を除く）
  kanji_choiki = kanji_choiki + row.to_a[8].to_s
  yomi_choiki = yomi_choiki + NKF.nkf('-wX', row.to_a[5].to_s)
else
  kanji_choiki = row.to_a[8].to_s if row.to_a[8].to_s =~ /^[^０-９－、・〜].*（.+）$/ or row.to_a[8].to_s =~ /^[^０-９－、・〜][^（）]*$/  # 町域が1行で収まる場合
  yomi_choiki = NKF.nkf('-wX', row.to_a[5].to_s)  if row.to_a[8].to_s =~ /^[^０-９－、・〜].*（.+）$/ or row.to_a[8].to_s =~ /^[^０-９－、・〜][^（）]*$/

  kanji_choiki = kanji_choiki + row.to_a[8].to_s if row.to_a[8].to_s =~ /^[^（]+）$/  # 町域が2行以上にまたがるケースの最終行
  yomi_choiki = yomi_choiki + NKF.nkf('-wX', row.to_a[5].to_s) if row.to_a[8].to_s =~ /^[^（]+）$/
  kanji_choiki = kanji_choiki.gsub(/(以下に掲載がない場合)/){"（" + $1 + "）"}
  yomi_choiki = yomi_choiki.gsub(/イカニケイサイガナイバアイ/, "").gsub(/\(.+\)/, "")
  zip_old = row.to_a[1].to_s.strip
  zip_old_hyphen = zip_old.gsub(/([0-9]{3})([0-9]{1,2})/){$1 + "-" + $2}
  zip_new = row.to_a[2].to_s.strip
  zip_new_hyphen = zip_new.gsub(/^([0-9]{3})([0-9])/){$1 + "-" + $2}
  yomi_todofuken = NKF.nkf('-wX', row.to_a[3])
  yomi_shichoson = NKF.nkf('-wX', row.to_a[4])
  yomi_choiki_noparen = yomi_choiki.gsub(/（.+）/, "")
  hira_todofuken = NKF.nkf('-wh1', yomi_todofuken)
  hira_shichoson = NKF.nkf('-wh1', yomi_shichoson)
  hira_choiki = NKF.nkf('-wh1', yomi_choiki_noparen)
  kanji_todofuken = row.to_a[6]
  kanji_shichoson = row.to_a[7]
  kanji_choiki_noparen = kanji_choiki.gsub(/（.+）/, "")
  title = zip_new_hyphen + "（" + kanji_todofuken + kanji_shichoson + kanji_choiki +"）"
  flg_1choiki2zip = row.to_a[9]
  flg_koaza = row.to_a[10]
  flg_chome = row.to_a[11]
  flg_1zip2choiki = row.to_a[12]
  flg_updated = row.to_a[13]
  flg_reason = row.to_a[14]

  print "<d:entry id=\"" + x.to_s + "\" d:title=\"" + title +"\">\n"
  if kanji_choiki_noparen != "" then
    print "\t<d:index d:value=\"" + kanji_choiki_noparen + "\" d:title=\"" + title +"\"/>\n"
  end
  print "\t<d:index d:value=\"" + kanji_shichoson + kanji_choiki_noparen + "\" d:title=\"" + title +"\"/>\n"
  print "\t<d:index d:value=\"" + kanji_todofuken + kanji_shichoson + kanji_choiki_noparen + "\" d:title=\"" + title +"\"/>\n"
  if yomi_choiki_noparen != "" then
    print "\t<d:index d:value=\"" + yomi_choiki_noparen + "\" d:title=\"" + title +"\"/>\n"
    print "\t<d:index d:value=\"" + hira_choiki + "\" d:title=\"" + title +"\"/>\n"
  end
  print "\t<d:index d:value=\"" + yomi_shichoson + yomi_choiki_noparen + "\" d:title=\"" + title +"\"/>\n"
  print "\t<d:index d:value=\"" + hira_shichoson + hira_choiki + "\" d:title=\"" + title +"\"/>\n"
  print "\t<d:index d:value=\"" + yomi_todofuken + yomi_shichoson + yomi_choiki_noparen + "\" d:title=\"" + title +"\"/>\n"
  print "\t<d:index d:value=\"" + hira_todofuken + hira_shichoson + hira_choiki + "\" d:title=\"" + title +"\"/>\n"

  print "\t<d:index d:value=\"" + zip_new + "\" d:title=\"" + title +"\"/>\n"
  print "\t<d:index d:value=\"" + zip_new_hyphen + "\" d:title=\"" + title +"\"/>\n"

  print "\t<h1>" + kanji_todofuken + kanji_shichoson + kanji_choiki + "</h1>\n"
  print "\t<p>"
  if flg_updated == "2" then
    print "\t※廃止\n"
  end
  print "\t〒"+ zip_new_hyphen + "<br />\n"
  print "\t" + kanji_todofuken + kanji_shichoson + kanji_choiki + "<br />\n"
  print "\t（" + ( hira_todofuken + " " + hira_shichoson + " "+ hira_choiki ).chomp + "）<br />\n"
  print "\t旧郵便番号：" + zip_old_hyphen + "\n"
  print "\t</p>\n"
  print "</d:entry>\n"

  kanji_choiki = ""
  yomi_choiki = ""
end
}
temp.close(true)

print "</d:dictionary>"

